static	char	sccsid[]="%Z% %M% %I% %E% %U%";
/*****************************************/
/*                                       */
/*                 cl_ct_clear           */
/*---------------------------------------*/
/*  XNvge[uƃvV[W[   */
/*  e[u̍폜                       */
/*---------------------------------------*/
/*                                       */
/*****************************************/
#include "colmn.h"

extern CLPRTBL   *pGLprocTable;
extern CLPRTBL   *pCLprocTable;
extern GlobalCt  *pGlobTable;
extern tdtLruScrHead *tpLruScrHeadImp;
extern tdtLruScrHead *tpLruScrHead;
extern CLNCB     CLSTCB;  /* ^O̍\͂s߂̗̈ */

int addrchk(file,line,p)
char *file;
int  line;
char *p;
{
	char w[128];

	if (!p) return 0;
	if (!akxm_addrchk(p)) {
		sprintf(w,"address invalid (0x%08x)",p);
		akb_error_out(file,line,w);
		return 0;
	}
	return 1;
}

int cl_ct_clear()
{
	ScrPrCT        *Dummy;
	SearchResult   *DummySE;
	ListPacBody    *DummyLP;
	VarTBL         *DummyVR;
	tdtCONSTCT     *DummyCN;
	AKAMSGCOM      *tpMsgCom;

	if (ADDRCHK(CLSTCB.TopStack)) {
		cl_leaf_clear(CLSTCB.TopStack);
		CLSTCB.TopStack = NULL;
	}
	if (pCLprocTable->CmdPacketp) {
		tpMsgCom = (AKAMSGCOM *)pCLprocTable->CmdPacketp;
		if (tpMsgCom->msg_pmsg) {
			Free(tpMsgCom->msg_pmsg);
			tpMsgCom->msg_pmsg = NULL;
		}
	}
	if (pCLprocTable->WaitPacketp) {
		Free(pCLprocTable->WaitPacketp);
		pCLprocTable->WaitPacketp = (char *)NULL;
	}
/*
printf("cl_ct_clear: Free: pCLprocTable->PrCTp=%08x\n",pCLprocTable->PrCTp);
*/
	if (ADDRCHK(pCLprocTable->PrCTp)) {
		Dummy = pCLprocTable->PrCTp;
		cl_scr_clear(Dummy);
		pCLprocTable->PrCTp = NULL;
	}

	if (ADDRCHK(pCLprocTable->SearchRsltF)) {
		DummySE = pCLprocTable->SearchRsltF;
		cl_rslt_clear(DummySE);
		pCLprocTable->SearchRsltF = NULL;
	}

	if (pCLprocTable->ListPBody != NULL) {
		cl_list_pac_clear(pCLprocTable->ListPBody);
		pCLprocTable->ListPBody = NULL;
	}
/*
printf("cl_ct_clear: Free: pCLprocTable->Vary=%08x\n",pCLprocTable->Vary);
*/
	if (ADDRCHK(pCLprocTable->Vary)) {
		DummyVR = pCLprocTable->Vary;
		vary_clear(DummyVR);
		pCLprocTable->Vary = NULL;
	}

	if (ADDRCHK(pCLprocTable->pha_vnam)) {
		akxs_xhash_free(pCLprocTable->pha_vnam);
		pCLprocTable->pha_vnam = NULL;
	}
	if (ADDRCHK(pCLprocTable->pTBL_vnam)) {
		cl_free_var_ent(pCLprocTable->pTBL_vnam);
		Free(pCLprocTable->pTBL_vnam[0]);
		Free(pCLprocTable->pTBL_vnam);
		pCLprocTable->pTBL_vnam = NULL;
	}

	if (ADDRCHK(pCLprocTable->pha_fp)) {
		cl_free_fp(pCLprocTable->pha_fp);
		pCLprocTable->pha_fp = NULL;
	}

	if (ADDRCHK(pCLprocTable->pha_env)) {
		cl_env_reset(pCLprocTable->pha_env);
		pCLprocTable->pha_env = NULL;
	}

	if (ADDRCHK(pCLprocTable->ConstCt)) {
		DummyCN = pCLprocTable->ConstCt;
		const_ct_clear ( DummyCN );
		pCLprocTable->ConstCt = NULL ;
	}
#if 0	/* 2021.7.13 */
	if (ADDRCHK(pCLprocTable->pha_gid)) {
		akxs_xhasl_free(pCLprocTable->pha_gid);
		pCLprocTable->pha_gid = NULL;
	}
#endif
	cl_tmp_const_clear(2);

	pCLprocTable->CurScr = NULL;
	pCLprocTable->CurProc = NULL;

	pGlobTable->tuppl  = 0;
	pGlobTable->column = 0;
	pGlobTable->error  = 0;
	pGlobTable->Return = 0;
	pGlobTable->Retval = NULL;
	pGlobTable->exception = 0;
	pGlobTable->try_level = 0;

	return ( 0 );

}

/**************************************************/
/*   XNvge[u̍폜 (cl_scr_clear)      */
/**************************************************/
static void _free_const(scrconst)
ScrConstCt *scrconst;
{
	Leaf *leaf;
	char *p;
	int  cno;

	if (leaf=scrconst->NodeLeaf) {
		if ((cno=leaf->cmd.cid)==C_NODE_IMPORT || cno==C_NODE_SCRIPT) {
/*
printf("_free_const: node=%08x pFlag=%02x\n",cno,leaf->pFlag);
*/
			if (leaf->pFlag & D_LEAF_CACHED) cl_lru_scr_era(scrconst->pId);
			else cl_leaf_clear(leaf->leftleaf);
			Free(leaf);
		}
	}
	if (p=scrconst->pId) Free(p);
	Free(scrconst);
}

int cl_scr_clear( Dummy )
ScrPrCT    *Dummy;
{
	int i,j,cno;
	ONTBL *pOntbl;
	char  *p;
	tdtRB_CTL *pCt;
	Leaf *leaf;
	tdtINFO_PARM **Obj0;
/*
printf("cl_scr_clear: Dummy=%08x [%s] called.\n",Dummy,Dummy->pId);
*/

	if (ADDRCHK(Dummy->ProCT)) {
		cl_prc_clear(Dummy->ProCT);
	}
	Dummy->ProCT = NULL;

	if (ADDRCHK(Dummy->Vary)) {
/*
printf("            [%s] start vary_clear.\n",Dummy->pId);
*/
		vary_clear( Dummy->Vary );
	}
	Dummy->Vary = NULL;
	if (Dummy->ONCOND) {
		for (i=0;i<Dummy->on_num_max;i++) {
			if (pOntbl = Dummy->ONCOND[i]) {
				for (j=0;j<4;j++) {
					if ((p=pOntbl->PrName[j])) Free(p);
				}
				Free (pOntbl);
			}
		}
		Free(Dummy->ONCOND);
		Dummy->ONCOND = NULL;
	}
	if ( ADDRCHK(Dummy->nextScCT) )  cl_scr_clear( Dummy->nextScCT );
	Dummy->nextScCT = NULL;
	if (!(Dummy->pFlag & D_LEAF_IMPORTMODE)) {
/*
printf("            [%s] pFlag=%02x\n",Dummy->pId,Dummy->pFlag);
*/
		if (Dummy->pFlag & D_LEAF_CACHED) cl_lru_scr_era(tpLruScrHead,Dummy->pId);
		else if (ADDRCHK(leaf=Dummy->TreeTop))  cl_leaf_clear(leaf);
	}
/*
printf("cl_scr_clear: Dummy->ConstCt=%08x\n",Dummy->ConstCt);
*/
	if (ADDRCHK(Dummy->ConstCt)) const_ct_clear(Dummy->ConstCt);

	if (pCt=Dummy->pListImport) {
		akxs_list_free(pCt,_free_const);
	}

	if (ADDRCHK(Dummy->Obj)) {
/*
printf("cl_scr_clear: Dummy->Obj=%08x\n",Dummy->Obj);
*/
		if (Obj0 = Dummy->Obj->Obj0) {
			if (Obj0[0]) Free(Obj0[0]);
			Free(Obj0);
		}
		Free(Dummy->Obj);
	}

	if (ADDRCHK(Dummy->ProcIndex)) {
		akxs_xhash_free(Dummy->ProcIndex);
	}

	Free(Dummy);
	return 0;
}

/***************************************************/
/*   vV[W[e[u̍폜 (cl_prc_clear)   */
/***************************************************/
/* add 2001.1.12 Koba */
int cl_prc_ct_clear(proc)
ProcCT    *proc;
{
	BlockCB *pBlockCB,*wB;
	tdtCONSTCT *DummyG;
	int i,j;
	tdtINFO_PARM **Obj0;
	char *p;

	if (!proc) return 0;

	cl_tmp_const_ct_set(NULL);

	pBlockCB = proc->pTopBlockCB;
	while (pBlockCB) {
		if (pBlockCB->pEachParm) Free(pBlockCB->pEachParm);
		wB = pBlockCB->nextBlockCB;
		Free (pBlockCB);
		pBlockCB = wB;
	}
	proc->pTopBlockCB = NULL;
	if (proc->INPCB.parmtop) {
		Free(proc->INPCB.parmtop);
		proc->INPCB.parmtop = NULL;
	}

	akxs_rb_free(proc->pRetStack);

	if (proc->pha_vnam) akxs_xhash_free(proc->pha_vnam);
	if (proc->pTBL_vnam) {
		if (!(proc->pFlag & D_PFLAG_PARM_COPY)) cl_free_var_ent(proc->pTBL_pasento);
		cl_free_var_ent(proc->pTBL_vnam);
		Free(proc->pTBL_vnam[0]);
		Free(proc->pTBL_vnam);
	}

	if (ADDRCHK(proc->ProcNM)) Free(proc->ProcNM);
	if (ADDRCHK(proc->pTmpConstCt)) const_ct_clear(proc->pTmpConstCt);
	if (ADDRCHK(proc->Obj)) {
		Obj0 = proc->Obj->Obj0;
		if (p=(char *)Obj0[0]) Free(p);
		Free(Obj0);
		Free(proc->Obj);
	}
	if (ADDRCHK(p=proc->ProcPath)) {
/*
printf("cl_prc_ct_clear: path=[%s]\n",p);
*/
		if (*p == '*') Free(p);
	}

	return 0;
}

int cl_prc_clear(Dummy)
ProcCT *Dummy;
{
	if (ADDRCHK(Dummy->nextPCT)) {
		cl_prc_clear(Dummy->nextPCT);
		Dummy->nextPCT = NULL;
	}
	cl_prc_ct_clear(Dummy);
	Free(Dummy);
	return 0;
}

/**********************************************/
/*                                            */
/*             cl_leaf_clear                  */
/*--------------------------------------------*/
/*                                            */
/*         @[te[u̍폜             */
/*--------------------------------------------*/
/*                                            */
/**********************************************/
/*  */
int cl_leaf_clear(Dummy)
Leaf *Dummy;
{
	Leaf *leaf;

	if (ADDRCHK(leaf=Dummy->rightleaf)) cl_leaf_clear(leaf);

	if (ADDRCHK(leaf=Dummy->leftleaf))  cl_leaf_clear(leaf);
	Free(Dummy);

	return 0;
}

/**********************************************/
/*                                            */
/*              cl_rslt_clear                 */
/*--------------------------------------------*/
/*                                            */
/*         ʍ\̂̍폜               */
/*--------------------------------------------*/
/*                                            */
/**********************************************/
/* */
int cl_rslt_clear( Dummy )
SearchResult *Dummy;
{
	cl_result_clear ( Dummy );
	Free ( Dummy );
	return ( 0 );
}

/***********************************************/
/*    ʍ\̂̍폜  (cl_result_clear)  */
/***********************************************/

int cl_result_clear(Dummy)
SearchResult *Dummy;
{
	if ( ADDRCHK(Dummy->Next) ){
		cl_result_clear(Dummy->Next);
		Free(Dummy->Next);
		Dummy->Next = NULL;
	}
	if ( Dummy->szType[0] == 'F' ) {
		if ( Dummy->pzFileName ) Free(Dummy->pzFileName);
	}
	else if ( Dummy->szType[0] == 'B' ) {
		if ( Dummy->iIndex ) Free ( Dummy->iIndex - 2);
		if ( Dummy->RslBody ) Free ( Dummy->RslBody );
		if ( Dummy->pzFileName ) Free(Dummy->pzFileName);
	}
	if (Dummy->sAreaId) Free(Dummy->sAreaId);
	return 0;
}

/***********************************************/
/*      CAEgf[^̏               */
/***********************************************/
/*   */

int cl_list_pac_clear(DummyA)
ListPacBody *DummyA ;
{
	if (ADDRCHK(DummyA)) {
		if (ADDRCHK(DummyA->mCat.mc_bufp)) Free(DummyA->mCat.mc_bufp);
	}
	return 0;
}

/******************************************************/
/*         p[^Xg ̏                  */
/******************************************************/
int prm_list_clear(DummyE)
prmList *DummyE;
{
	if (DummyE->VarBD) Free(DummyE->VarBD);
	return 0;
}

int info_parm_clear(DummyE)
tdtINFO_PARM *DummyE;
{
	cl_free_info_parm(DummyE);
	memset(DummyE,0,sizeof(tdtINFO_PARM));
	return 0;
}

/*******************************************************/
/*           ϐe[ȕ                      */
/*******************************************************/
int vary_clear(DummyF)
VarTBL *DummyF;
{
	int  i;

	cl_free_var_ent(DummyF->pTBL_igeta);
	cl_free_var_ent(DummyF->pTBL_pasento);
	cl_free_var_ent(DummyF->pTBL_dolu);

	cl_free_var_ent(DummyF->pTBL_vnam);
	akxs_xhash_free(DummyF->pha_vnam);

	Free(DummyF->pTBL_dolu[0]);
	Free(DummyF->pTBL_dolu);

	Free(DummyF);
	return 0;
}

/*******************************************************/
/*           CONSTANTe[ȕ                  */
/*******************************************************/
int const_ct_clear(DummyG)
tdtCONSTCT *DummyG;
{
	if (ADDRCHK(DummyG)) {
		akxm_cct_mem_free(DummyG);
	}
	return 0;
}
