static char sccsid[]="%Z% %M% %I% %D% %T%";
/*****************************************************/
/*                                                   */
/*       Database Interface Program for FILE         */
/*                                                   */
/*           coded by A.Kobayashi  2010.05.28        */
/*                                                   */
/*****************************************************/
#include "somn.h"

#define PORA(x)

static char *nullstring=" ";
SQLCA sqlca
         = {
         {'S', 'Q', 'L', 'C', 'A', ' ', ' ', ' '},
         sizeof(SQLCA),
         0,
         { 0, {0}},
         {'N', 'O', 'T', ' ', 'S', 'E', 'T', ' '},
         {0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0}
         }
         ;
static SQLDA *bind_dp;
static SQLDA *select_dp;

static CURSOR C;

static int precision,scale;
static int null_ok;
static short *indicator;
/* static short indicate[MAX_COLUMN]; */
static char  errmsg[71];

int di_connect_ora(pdipCT)
qDipCT *pdipCT;
{
	qParm *p;
	int ret=0;

	p = pdipCT->pparm;
/*******************************************************
	if (p->logname) {
		strcpy(username.arr,p->logname);
		username.len=strlen(username.arr);
	}
	if (p->password) {
		strcpy(password.arr,p->password);
		password.len=strlen(password.arr);
	}
	if (p->userid) {
		strcpy(userid.arr,p->userid);
		userid.len=strlen(userid.arr);
	}
	if (p->netname) {
		strcpy(db_string.arr,p->netname);
		db_string.len=strlen(db_string.arr);
	}

	if (p->netname && *(p->netname)) {
		if (p->userid) {
			printf("EXEC SQL CONNECT :userid USING :db_string\n");
		}
		else {
			if (!p->logname || !(p->password)) return (ERROR_LOGIN);
			printf("EXEC SQL CONNECT :username IDENTIFIED BY :password USING :db_string\n");
		}
	}
	else {
		if (p->userid) {
			printf("EXEC SQL CONNECT :userid\n");
		}
		else {
			if (!p->logname || !(p->password)) return (ERROR_LOGIN);
			printf("EXEC SQL CONNECT %s IDENTIFIED BY %s\n",p->logname,p->password);
		}
	}
*****************************************************/
	fil_connect(p->database);
	memcpy(errmsg,sqlca.sqlerrm.sqlerrmc,sqlca.sqlerrm.sqlerrml);
	errmsg[sqlca.sqlerrm.sqlerrml] = '\0';
	pdipCT->sqlcode = sqlca.sqlcode;
	if (sqlca.sqlcode) ret = ERROR_ORACLE;
	return (ret);
}

SQLDA *sqlald(x,y,z)
int x,y,z;
{
	SQLDA *p;
	int i;

	p = (SQLDA *)Malloc(sizeof(SQLDA));
	p->N = x;
	p->T = (short *)Malloc(x*sizeof(short));
	p->I = (short **)Malloc(x*sizeof(short *));
	p->L = (long *)Malloc(x*sizeof(long));
	p->S = (char **)Malloc(x*sizeof(char *));
	p->V = (char **)Malloc(x*sizeof(char *));
	p->X = (char **)Malloc(x*sizeof(char *));
	p->M = (short *)Malloc(x*sizeof(short));
	p->C = (short *)Malloc(x*sizeof(short));
	p->Y = (short *)Malloc(x*sizeof(short));
	p->Z = (short *)Malloc(x*sizeof(short));
#ifdef OLD_CASH
	p->LS= x*(y+1);
	p->S[0]=Malloc(p->LS);
#else
	p->S[0]=Malloc(x*(y+1));
	p->I[0]=(short *)Malloc(x*sizeof(short));
#endif
	for (i=1;i<x;i++) {
		p->S[i]=p->S[i-1]+(y+1);
		p->I[i]=p->I[i-1]+sizeof(short);
	}
	for (i=0;i<x;i++) {
		p->V[i]=NULL;
		p->X[i]=NULL;
		p->Y[i]=y;
	}
	return p;
}

void sqlclu(p)
SQLDA *p;
{
	int i;

	if (!p) return;
	for (i=0;i<p->N;i++) {
		if (p->V[i]) Free(p->V[i]);
		if (p->X[i]) Free(p->X[i]);
	}
	if (p->S[0]) Free(p->S[0]);
	if (p->I[0]) Free(p->I[0]);
	if (p->T) Free(p->T);
	if (p->I) Free(p->I);
	if (p->L) Free(p->L);
	if (p->S) Free(p->S);
	if (p->V) Free(p->V);
	if (p->X) Free(p->X);
	if (p->M) Free(p->M);
	if (p->C) Free(p->C);
	if (p->Y) Free(p->Y);
	if (p->Z) Free(p->Z);
	Free(p);
}

int di_init_ora(pdipCT)
qDipCT  *pdipCT;
{
	qDist *iitmn;
	int i;

	if (!(bind_dp = sqlald(MAX_COLUMN,30,30))) return(ERROR_MALLOC);
	bind_dp->N = MAX_COLUMN;
	if (!(select_dp = sqlald(MAX_COLUMN,30,30))) return(ERROR_MALLOC);
	select_dp->N = MAX_COLUMN;

	C.bind   = bind_dp;
	C.select = select_dp;
	C.tblnam = NULL;
	C.fp     = NULL;
	C.rec    = NULL;
	C.tptc   = NULL;

	iitmn = pdipCT->piitmn;
	for (i=0;i<MAX_COLUMN;i++) {
		iitmn[i].attr.dtype = TYPE_ORA_CHAR;
		iitmn[i].cpDat = select_dp->S[i];
		iitmn[i].len = 30;
	/*
		if (!(select_dp->V[i] = Malloc(257))) return(ERROR_MALLOC);
	*/
	}

	pdipCT->errormsg = errmsg;

	fil_init();

	return(0);
}

int di_pre_ora(psql,pdipCT)
char *psql;
qDipCT *pdipCT;
{
	int i;
	char variable[32], *pdat;
	qDist *idist, *odist, *iitmn;
/*
	C.bind   = bind_dp;
	C.select = select_dp;
	bind_dp->N   = MAX_COLUMN;
*/
#ifndef OLD_CASH
	C.bind   = bind_dp;
	bind_dp->N   = MAX_COLUMN;
#endif
	select_dp->N = MAX_COLUMN;

	idist = pdipCT->pidist;
	iitmn = pdipCT->piitmn;
	odist = pdipCT->podist;
/*	pdat  = pdipCT->inbuf;  */

	PORA(printf("EXEC SQL PREPARE S FROM :statement\n");)
	fil_prepare(psql,&C);
	if (sqlca.sqlcode) goto SqlErr;

	PORA(printf("EXEC SQL OPEN C USING DESCRIPTOR select_dp\n");)
	fil_cursor_open(&C);
	if (sqlca.sqlcode) goto SqlErr;
/*
printf("di_pre_ora: sel F=%d, bnd F=%d\n",select_dp->F,bind_dp->F);
*/
	if (select_dp->F < 0) {
		PORA(printf("Too many select-list items for: %d\n",-(select_dp->F));)
		return(ERROR_TOO_MANY);
	}
/*
	select_dp->N = select_dp->F;
*/
	for (i=0;i<select_dp->F;i++) {
		idist[i].attr.pre   = 0;
		idist[i].attr.scale = 0;
		odist[i].attr.dtype = select_dp->T[i];
		PORA(printf ("i=%d type=%d L=%d",i,select_dp->T[i],select_dp->L[i]);)
		switch (select_dp->T[i] & 0x0f) {
			case TYPE_FIL_CHAR:
				idist[i].len = select_dp->L[i];
				break;
			case TYPE_FIL_INTEGER:
				select_dp->T[i] = TYPE_FIL_CHAR;
				select_dp->L[i] = 12;
				idist[i].attr.pre   = precision;
				idist[i].attr.scale = scale;
				idist[i].len = select_dp->L[i];
				break;
			case TYPE_FIL_BULK:
				/*
				select_dp->L[i] = MAX_LONG_SIZE;
				select_dp->T[i] = TYPE_FIL_BULK;
				*/
				idist[i].len = select_dp->L[i];
				break;
			case TYPE_FIL_DATE:
				select_dp->T[i] = TYPE_FIL_CHAR;
				select_dp->L[i] = 19;
				idist[i].len = select_dp->L[i];
				break;
		}
		PORA(printf (" --> type=%d L=%d\n",select_dp->T[i],select_dp->L[i]);)
#if 0
		if (select_dp->V[i]) Free(select_dp->V[i]);
		if (!(select_dp->V[i] = Malloc(idist[i].len+1)))
			return ERROR_MALLOC;
#else
		if (!select_dp->V[i]) {
			if (!(select_dp->V[i]=Malloc(idist[i].len+1)))
				return ERROR_MALLOC;
		}
		else {
			if (!(select_dp->V[i]=Realloc(select_dp->V[i],idist[i].len+1)))
				return ERROR_MALLOC;
		}
#endif
	/*	select_dp->I[i] = &indicate[i];	*/
		idist[i].attr.dtype = select_dp->T[i];
		idist[i].cpDat = select_dp->V[i];
/*
printf("i=%d, attr.dtype=%d, attr.pre=%d, attr.scale=%d, attr.flag=%d, cpDat=%08x, len=%d\n",i,idist[i].attr.dtype,idist[i].attr.pre,idist[i].attr.scale,idist[i].attr.flag,idist[i].cpDat,idist[i].len);
*/
	}
	pdipCT->nidist = select_dp->F;

	return (0);
SqlErr:
	PORA(printf("di_pre_ora:sqlcode=%d\n",sqlca.sqlcode);)
	memcpy(errmsg,sqlca.sqlerrm.sqlerrmc,sqlca.sqlerrm.sqlerrml);
	errmsg[sqlca.sqlerrm.sqlerrml] = '\0';
	pdipCT->sqlcode = sqlca.sqlcode;
	return sqlca.sqlcode;
}

int di_fetch_ora(pdipCT)
qDipCT *pdipCT;
{
	fil_fetch(&C);
	pdipCT->sqlcode = sqlca.sqlcode;
	memcpy(errmsg,sqlca.sqlerrm.sqlerrmc,sqlca.sqlerrm.sqlerrml);
	errmsg[sqlca.sqlerrm.sqlerrml] = '\0';
	return (sqlca.sqlcode);
}

int di_eof_ora(pdipCT)
qDipCT *pdipCT;
{
int i;

	PORA(printf("\nNumber of rows processed = %d\n",sqlca.sqlerrd[2]);)
	fil_cursor_close(&C);
	pdipCT->sqlcode = sqlca.sqlcode;
	PORA(printf("EXEC SQL CLOSE C\n");)
	return (sqlca.sqlerrd[2]);
}

int di_end_ora()
{
	int i;

	for (i=0;i<select_dp->N;i++) {
		if (select_dp->V[i]) {
			Free(select_dp->V[i]);
			select_dp->V[i] = NULL;
		}
	}
	sqlclu(bind_dp);
	sqlclu(select_dp);
	return (0);
}

int di_disconnect_ora(pdipCT)
qDipCT *pdipCT;
{
	int ret = 0;

	PORA(printf("EXEC SQL DISCONNECT\n");)
/*
	memcpy(errmsg,sqlca.sqlerrm.sqlerrmc,sqlca.sqlerrm.sqlerrml);
	errmsg[sqlca.sqlerrm.sqlerrml] = '\0';
	pdipCT->sqlcode = sqlca.sqlcode;
	if (sqlca.sqlcode) ret = ERROR_ORACLE;
*/
	return (ret);
}

int di_exec_sql_ora(sql,pdipCT)
char *sql;
qDipCT *pdipCT;
{
	char temp[256];

	strncpy(temp,sql,sizeof(temp)-1);
	temp[sizeof(temp)-1]='\0';
	PORA(printf("EXEC SQL EXECUTE [%s]\n",temp);)

#ifndef OLD_CASH
	C.bind   = bind_dp;
	bind_dp->N   = MAX_COLUMN;
#endif
	fil_exec_sql(sql,&C);
	pdipCT->sqlcode = sqlca.sqlcode;
	memcpy(errmsg,sqlca.sqlerrm.sqlerrmc,sqlca.sqlerrm.sqlerrml);
	errmsg[sqlca.sqlerrm.sqlerrml] = '\0';
	return (sqlca.sqlcode);
}

int di_start_tr_ora()
{
	PORA(printf("EXEC SQL START TRANSACTION\n");)
	return 0;
}

int di_commit_ora()
{
	PORA(printf("EXEC SQL COMMIT WORK\n");)
	return 0;
}

int di_rollback_ora()
{
	PORA(printf("EXEC SQL ROLLBACK WORK\n");)
	return 0;
}

CURSOR *di_cursor_ora()
{
	return &C;
}
