/*static char sccsid[]="%Z% %M% %I% %D% %T%";*/
#define TYPE_FIL_CHAR		1
#define TYPE_FIL_INTEGER	2
#define TYPE_FIL_FLOAT		3
#define TYPE_FIL_DECIMAL	4
#define TYPE_FIL_BULK		5
#define TYPE_FIL_ROWID		11
#define TYPE_FIL_DATE		12

#define TYPE_ORA_CHAR		1
#define TYPE_ORA_NUMBER		2
#define TYPE_ORA_LONG		8
#define TYPE_ORA_ROWID		11
#define TYPE_ORA_DATE		12
#define TYPE_ORA_RAW		23
#define TYPE_ORA_LONGRAW	24
#define TYPE_ORA_VARCHAR	9
#define TYPE_ORA_VARRAW		15

#define TYPE_STY_A		0
#define TYPE_STY_X		3
#define TYPE_STY_M		4
#define TYPE_STY_J		5
#define TYPE_STY_N		11

#define TYPE_COM_APPEND		255

#define CMD_EDIT_COPY	1
#define CMD_EDIT_A	100
#define CMD_EDIT_X	103
#define CMD_EDIT_M	104
#define CMD_EDIT_J	105
#define CMD_EDIT_N	111

#define MASK1_POS_ADDR	0x01
#define MASK1_POS_DATA	0x02

#define ERROR_HELP			 14110000
#define ERROR_NO_ARG		-14110001
#define ERROR_NOT_ARG		-14110002
#define ERROR_INVALID_ARG	-14110003
#define ERROR_MALLOC		-14110004
#define ERROR_NOT_COMMAND	-14110005
#define ERROR_NO_SQL		-14110006
#define ERROR_NOT_SELECT	-14110007
#define ERROR_NO_REFFILE	-14110008
#define ERROR_NO_REFSTR		-14110009
#define ERROR_OPEN			-14110010
#define ERROR_READ			-14110011
#define ERROR_WRITE			-14110012
#define ERROR_LOGIN			-14110013
#define ERROR_TOO_MANY		-14110014
#define ERROR_NO_TABLENAME	-14110015
#define ERROR_NO_OUTCOLUMN	-14110016
#define ERROR_SYNTAX		-14110017
#define ERROR_COND_NCLM		-14110018
#define ERROR_NOT_COLNAME	-14110019
#define ERROR_NO_VALUE		-14110020
#define ERROR_NO_DBNAME		-14110021
#define ERROR_COMPILE		-14110022
#define ERROR_EXEC_OBJ		-14110023
#define ERROR_MAX_OBJ		-14110024
#define ERROR_MAX_DA		-14110025
#define ERROR_MAX_TREE		-14110026
#define ERROR_MAX_NEST		-14110027
#define ERROR_DATE_FORMAT	-14110028
#define ERROR_ORACLE		-14110000
#define ERROR_SQL_EOF		100

#define MAX_COLUMN	50
#define MAX_OUTBUF	MAX_COLUMN*33
#define MAX_SQL_SIZE	40960
#define MAX_SEG_SIZE	65536
#define MAX_LONG_SIZE	65535
#define MAX_VCHAR_SIZE	65533

#define FIL_MAX_OBJ		1000
#define FIL_MAX_DA		400
#define FIL_MAX_TREE	1000
#define FIL_MAX_NEST	400

#define ENVFILE		"fil.env"

#define ID_LOGIN	"LOGIN"
#define ID_PASSWD	"PASSWD"
#define ID_DBNAME	"DBNAME"
#define ID_NETNAME	"NETNAME"
#define ID_RCSTRUCT	"RCSTRUCT"
#define ID_USERID	"USERID"
#define ID_BUFSIZE	"BUFSIZE"
#define ROWID_NAM	"rowid"
#define LOGID_NAM	"logid"

#define IXFLG_IX_WHERE	0x01	/* whereINDEX݂̂Ŏsł */
#define IXFLG_IX_SELECT	0x02	/* selectڂINDEX̂ */
#define IXFLG_IX_NEST	0x04	/* rowid or INDEXJ܂ރlXg */
#define IXFLG_IX_ROWID	0x08	/* whererowid̂ */

#define FIL_WDATTR_LP		1
#define FIL_WDATTR_RP		2
#define FIL_WDATTR_HUT		3
#define FIL_WDATTR_MUL		4
#define FIL_WDATTR_DEV		5
#define FIL_WDATTR_PLUS		6
#define FIL_WDATTR_MINUS	7
#define FIL_WDATTR_NE		11
#define FIL_WDATTR_GE		12
#define FIL_WDATTR_LE		13
#define FIL_WDATTR_EQ		14
#define FIL_WDATTR_GT		15
#define FIL_WDATTR_LT		16
#define FIL_WDATTR_LIKE		17
#define FIL_WDATTR_AND		21
#define FIL_WDATTR_OR		22
#define FIL_WDATTR_PUSH		31
#define FIL_WDATTR_EXIT		99
#define FIL_WDATTR_CCLM		100
#define FIL_WDATTR_ICLM		200
#define FIL_WDATTR_DATA		500

typedef struct qSqllist {
	char	*sql;
	struct qSqllist *sqllist;
} qSqllist;

typedef struct qParm {
	char 	*envfile;
	char	*logname;
	char	*password;
	char	*userid;
	char	*database;
	char	*netname;
	char	*msgfile;
	char	*service;
	char	*codekind;
	char	*index;
	long	buf_size;
} qParm;
/*
typedef unsigned char uchar;
*/
typedef struct qAttr {
	uchar	dtype;
	uchar	pre;
	uchar	scale;
	char	flag;
} qAttr;

typedef struct qDist {
	qAttr	attr;
	char	*cpDat;
	long	len;
} qDist;

typedef struct qCommand {
	char	ctype;
	char	yobi;
	short	cmd;
} qCommand;

typedef struct qEdist {
	qCommand	com;
	qAttr		iattr;
	long		ilen;
	qAttr		oattr;
	long		olen;
} qEdist;

typedef struct qClist {
	qCommand com;
	qAttr	iattr;
	char	*iaddr;
	long	ilen;
	qAttr	oattr;
	char	*oaddr;
	long	olen;
} qClist;
	
typedef struct {
	qParm	*pparm;
	long	nidist;
	qDist	*pidist;
	qDist	*piitmn;
	long	nodist;
	qDist	*podist;
	long	nclist;
	qClist	*pclist;
	char	*inbuf;
	char	*outbuf;
	char	*errormsg;
	long	sqlcode;
	long	tuple;
	long	outlen;
} qDipCT;

typedef struct
         {
          char    sqlcaid[8];
          long    sqlabc;
          long    sqlcode;
         struct
           {
            unsigned short sqlerrml;
            char           sqlerrmc[70];
           } sqlerrm;
          char    sqlerrp[8];
          long    sqlerrd[6];
          char    sqlwarn[8];
          char    sqlext[8];
} SQLCA;

typedef struct {
  long    N;
  char  **V;
  long   *L;
  short  *T;
  short **I;
  long    F;
  char  **S;
  short  *M;
  short  *C;
  char  **X;
  short  *Y;	/* eS[i]̗L */
  short  *Z;
#ifdef OLD_CACHE
  long    LS;	/* S̃AP[g */
#endif
} SQLDA;

typedef struct {
	int  iAlloc;
	int  iUsed;
	long *lpPos;
	char **cppData;
} INDEX;

typedef struct TABLE_CACHE {
/*
	char *cpTableName;
*/
	INDEX *tpIndex;
	char *tblnam;
	SQLDA *bndp;
} TABLECACHE;

SQLDA *sqlald();	/*	(int ,int ,int );	*/

typedef struct _WHERE_TREE {
	int mcode;
	int t1;
	int t2;
	int lv;
	int uv;
/*
	struct _WHERE_TREE *t1;
	struct _WHERE_TREE *t2;
*/
} WHERE_TREE;

typedef struct {
	char *tblnam;
	SQLDA *bind;
	SQLDA *select;
	FILE *fp;
	short nobj;
	short nnest;
	int   *obj;
	WHERE_TREE *tree;
	short *nest;
	short *nest_flg;
	char **rec;
	TABLECACHE *tptc;
	short ixflg;
	short inflg;
	short isflg;
	short icflg;
	char **sumrec;
} CURSOR;

CURSOR *di_cursor_ora();
